(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/animations'), require('@angular/router'), require('a4-overlay'), require('rxjs/add/operator/filter'), require('@angular/common'), require('@angular/platform-browser/animations')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/animations', '@angular/router', 'a4-overlay', 'rxjs/add/operator/filter', '@angular/common', '@angular/platform-browser/animations'], factory) :
	(factory((global['a4-modal'] = global['a4-modal'] || {}),global['ng-core'],global['ng-animations'],global['ng-router'],global['a4-overlay'],global['rxjs-filter'],global['ng-common'],global['ng-platform-browser-animations']));
}(this, (function (exports,_angular_core,_angular_animations,_angular_router,a4Overlay,rxjs_add_operator_filter,_angular_common,_angular_platformBrowser_animations) { 'use strict';

var ModalComponent = /** @class */ (function () {
    function ModalComponent(resolver, router, overlayService) {
        this.resolver = resolver;
        this.router = router;
        this.overlayService = overlayService;
        this.scaling = false;
    }
    ModalComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (!!this.width) {
            this.hostWidth = this.width;
        }
        if (!!this.height) {
            this.hostHeight = this.height;
        }
        var factory = this.resolver.resolveComponentFactory(this.injectComponent.component);
        this.componentRef = this.viewContainerRef.createComponent(factory);
        if (!!this.injectComponent.inputs) {
            Object.keys(this.injectComponent.inputs)
                .forEach(function (key) { return _this.componentRef.instance[key] = _this.injectComponent.inputs[key]; });
        }
        this.componentRef.instance.modal = this;
        this.scaling = true;
        this.subscription = this.router.events
            .filter(function (p) { return p instanceof _angular_router.NavigationStart; })
            .subscribe(function () {
            _this.componentRef.destroy();
            _this.injectComponent.reject();
        });
        this.overlayService.show();
    };
    ModalComponent.prototype.ngOnDestroy = function () {
        this.overlayService.hide();
        this.subscription.unsubscribe();
    };
    ModalComponent.prototype.close = function (result) {
        this.result = result;
        this.scaling = false;
    };
    ModalComponent.prototype.animationDone = function (e) {
        if (!e.toState) {
            this.injectComponent.resolve(this.result);
            this.componentRef.destroy();
        }
    };
    ModalComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: 'a4-modal',
                    template: "<ng-template #container></ng-template>",
                    styles: ["\n  :host {\n    display: block;\n    position: fixed;\n    z-index: 1000;\n    background-color: white;\n    left: 50vw;\n    top: 50vh;\n    border: 1px solid rgba(0,0,0,0.1);\n    border-radius: 4px;\n    box-shadow: 0 5px 5px -3px rgba(0,0,0,.2), 0 8px 10px 1px rgba(0,0,0,.14), 0 3px 14px 2px rgba(0,0,0,.12);\n  }\n  "],
                    animations: [
                        _angular_animations.trigger('scaling', [
                            _angular_animations.state('0', _angular_animations.style({ transform: 'translate(-50%, -50%) scale(0)' })),
                            _angular_animations.state('1', _angular_animations.style({ transform: 'translate(-50%, -50%) scale(1)' })),
                            _angular_animations.transition(':enter', [_angular_animations.style({ transform: 'translate(-50%, -50%) scale(0)' }), _angular_animations.animate('250ms ease')]),
                            _angular_animations.transition('1 => 0', _angular_animations.animate('250ms ease'))
                        ])
                    ],
                    changeDetection: _angular_core.ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    ModalComponent.ctorParameters = function () { return [
        { type: _angular_core.ComponentFactoryResolver, },
        { type: _angular_router.Router, },
        { type: a4Overlay.OverlayService, },
    ]; };
    ModalComponent.propDecorators = {
        'injectComponent': [{ type: _angular_core.Input },],
        'width': [{ type: _angular_core.Input },],
        'height': [{ type: _angular_core.Input },],
        'viewContainerRef': [{ type: _angular_core.ViewChild, args: ['container', { read: _angular_core.ViewContainerRef },] },],
        'scaling': [{ type: _angular_core.HostBinding, args: ['@scaling',] },],
        'hostWidth': [{ type: _angular_core.HostBinding, args: ['style.width',] },],
        'hostHeight': [{ type: _angular_core.HostBinding, args: ['style.height',] },],
        'animationDone': [{ type: _angular_core.HostListener, args: ['@scaling.done', ['$event'],] },],
    };
    return ModalComponent;
}());

var ModalService = /** @class */ (function () {
    function ModalService(resolver, applicationRef) {
        this.resolver = resolver;
        this.applicationRef = applicationRef;
    }
    Object.defineProperty(ModalService.prototype, "viewContainerRef", {
        get: function () {
            var appInstance = this.applicationRef.components[0].instance;
            if (!appInstance.viewContainerRef) {
                var appName = this.applicationRef.componentTypes[0].name;
                throw new Error("Missing 'viewContainerRef' declaration in " + appName + " constructor");
            }
            return appInstance.viewContainerRef;
        },
        enumerable: true,
        configurable: true
    });
    ModalService.prototype.open = function (component, inputs, width, height) {
        var _this = this;
        var componentRef;
        return new Promise(function (mainResolve, mainReject) {
            new Promise(function (resolve, reject) {
                setTimeout(function () {
                    var factory = _this.resolver.resolveComponentFactory(ModalComponent);
                    componentRef = _this.viewContainerRef.createComponent(factory);
                    componentRef.instance['injectComponent'] = {
                        component: component, inputs: inputs, resolve: resolve, reject: reject
                    };
                    componentRef.instance.width = width;
                    componentRef.instance.height = height;
                }, 0);
            }).then(function (result) {
                componentRef.destroy();
                mainResolve(result);
            }).catch(function (reason) {
                componentRef.destroy();
                mainReject(reason);
            });
        });
    };
    ModalService.decorators = [
        { type: _angular_core.Injectable },
    ];
    /** @nocollapse */
    ModalService.ctorParameters = function () { return [
        { type: _angular_core.ComponentFactoryResolver, },
        { type: _angular_core.ApplicationRef, },
    ]; };
    return ModalService;
}());

var ModalModule = /** @class */ (function () {
    function ModalModule() {
    }
    ModalModule.decorators = [
        { type: _angular_core.NgModule, args: [{
                    imports: [
                        _angular_common.CommonModule,
                        _angular_router.RouterModule,
                        _angular_platformBrowser_animations.BrowserAnimationsModule
                    ],
                    declarations: [
                        ModalComponent
                    ],
                    entryComponents: [
                        ModalComponent
                    ],
                    providers: [
                        ModalService
                    ]
                },] },
    ];
    /** @nocollapse */
    ModalModule.ctorParameters = function () { return []; };
    return ModalModule;
}());

exports.ModalComponent = ModalComponent;
exports.ModalService = ModalService;
exports.ModalModule = ModalModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
