import { OnInit, Type, ViewContainerRef, ComponentFactoryResolver, ComponentRef, AnimationTransitionEvent, OnDestroy } from '@angular/core';
import { Router } from '@angular/router';
import { Subscription } from 'rxjs/Subscription';
import { InputType } from '../service/modal.service';
import { OverlayService } from 'a4-overlay';
import 'rxjs/add/operator/filter';
export interface InjectComponent {
    component: Type<any>;
    inputs: InputType;
    resolve: (value?: any | PromiseLike<any>) => void;
    reject: (reason?: any) => void;
}
export interface IModal {
    modal: ModalComponent;
}
export declare class ModalComponent implements OnInit, OnDestroy {
    private resolver;
    private router;
    private overlayService;
    injectComponent: InjectComponent;
    width: string;
    height: string;
    viewContainerRef: ViewContainerRef;
    scaling: boolean;
    hostWidth: string;
    hostHeight: string;
    componentRef: ComponentRef<any>;
    result: any;
    subscription: Subscription;
    constructor(resolver: ComponentFactoryResolver, router: Router, overlayService: OverlayService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    close<T>(result: T): void;
    animationDone(e: AnimationTransitionEvent): void;
}
